import 'package:flutter/material.dart';

class Search extends StatefulWidget {
  final ScrollController controll;
  final List list;
  //从list中筛选搜索的数据
  final Widget endwidget;
  //末尾的一个Widget，作者自己需要所添加，非必须
  final callback;
  //当搜索框改变时所调用,返回List<int>,其中int值为筛选后的List的index
  final int itemheight;
  //List<Widget>中每一个item的高度
  const Search(
      {Key key,
      @required this.controll,
      @required this.list,
      this.endwidget,
      this.callback,
      @required this.itemheight})
      : super(key: key);
  @override
  _SearchState createState() => _SearchState();
}


class _SearchState extends State<Search> {
  final TextEditingController _textcontroller0 = new TextEditingController();

List<int> _ser = [];
int _sern = -1;
  @override
  Widget build(BuildContext context) {
    Widget end;
    if (widget.endwidget != null) {
      end = widget.endwidget;
    }
    return Stack(
      children: <Widget>[
        Theme(
          data: ThemeData(
            primaryColor: Colors.transparent,
          ),
          child: TextField(
            style: TextStyle(
              color: Colors.white,
            ),
            onChanged: (str) {
              _ser.clear();
              _sern = -1;
              for (String str in widget.list) {
                if (str.toString().contains(_textcontroller0.text) &&
                    _textcontroller0.text.isNotEmpty) {
                  _ser.add(widget.list.indexOf(str));
                }
              }
              if (widget.callback != null) widget.callback(_ser);
            },
            cursorColor: Colors.white,
            controller: _textcontroller0,
            keyboardType: TextInputType.text,
            decoration: new InputDecoration(
              border: OutlineInputBorder(),
              fillColor: Colors.white10,
              filled: true,
              contentPadding: const EdgeInsets.only(top: 10.0, left: 4),
            ),
            autofocus: true,
          ),
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.end,
          children: <Widget>[
            Container(
              decoration:
                  BoxDecoration(borderRadius: BorderRadius.circular(25)),
              height: 30,
              width: 30,
              child: InkWell(
                borderRadius: BorderRadius.circular(25),
                child: const Icon(Icons.arrow_upward),
                onTap: () {
                  if (_sern != 0) {
                    int time = (widget.controll.offset.toInt() -
                            _ser[_sern - 1] * widget.itemheight 
                            ) /
                        widget.itemheight ~/
                        3+1;
                    widget.controll.animateTo(
                        (_ser[_sern - 1]) * widget.itemheight.toDouble(),
                        duration:
                            Duration(milliseconds: time.abs() * 100), //跳转过去的时间
                        curve: Curves.ease);
                  }
                  if (_sern > 0) _sern--;
                },
              ),
            ),
            Container(
              decoration:
                  BoxDecoration(borderRadius: BorderRadius.circular(25)),
              height: 30,
              width: 30,
              child: InkWell(
                borderRadius: BorderRadius.circular(25),
                child: const Icon(Icons.arrow_downward),
                onTap: () {
                  if (_sern != _ser.length - 1) {
                    int time = (widget.controll.offset.toInt() -
                            _ser[_sern + 1] * widget.itemheight) /
                        widget.itemheight ~/
                        3+1;
                        print(time);
                    widget.controll.animateTo(
                        (_ser[_sern + 1]) * widget.itemheight.toDouble(),
                        duration:
                            Duration(milliseconds: time.abs() * 100), //跳转过去的时间
                        curve: Curves.ease);
                  }
                  if (_sern < _ser.length - 1) _sern++;
                  print(_sern);
                },
              ),
            ),
            end,
          ],
        )
      ],
    );
  }
}
